"""Add database_use_schema to Workspace

Revision ID: 1f410bdb7d63
Revises: 3b349d4ffa69
Create Date: 2023-08-20 15:33:44.544563

"""
import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import postgresql

import fief

# revision identifiers, used by Alembic.
revision = "1f410bdb7d63"
down_revision = "3b349d4ffa69"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "workspaces", sa.Column("database_use_schema", sa.Boolean(), nullable=True)
    )

    op.execute(
        "UPDATE workspaces SET database_use_schema = TRUE WHERE database_type IS NOT NULL;"
    )
    op.execute(
        "UPDATE workspaces SET database_use_schema = FALSE WHERE database_type IS NULL;"
    )

    connection = op.get_bind()
    if connection.dialect.name == "sqlite":
        with op.batch_alter_table("workspaces") as batch_op:
            batch_op.alter_column(
                "database_use_schema",
                existing_nullable=True,
                nullable=False,
                existing_type=sa.Boolean(),
            )
    else:
        op.alter_column(
            "workspaces",
            "database_use_schema",
            existing_nullable=True,
            nullable=False,
            existing_type=sa.Boolean(),
        )

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column("workspaces", "database_use_schema")
    # ### end Alembic commands ###
