"""Add database_table_prefix to Workspace

Revision ID: c8cf076d3ffa
Revises: 1f410bdb7d63
Create Date: 2023-08-28 16:56:32.354188

"""
import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import postgresql

import fief

# revision identifiers, used by Alembic.
revision = "c8cf076d3ffa"
down_revision = "1f410bdb7d63"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "workspaces",
        sa.Column("database_table_prefix", sa.String(length=255), nullable=True),
    )

    op.execute("UPDATE workspaces SET database_table_prefix = 'fief_'")

    connection = op.get_bind()
    if connection.dialect.name == "sqlite":
        with op.batch_alter_table("workspaces") as batch_op:
            batch_op.alter_column(
                "database_table_prefix",
                existing_nullable=True,
                nullable=False,
                existing_type=sa.String(length=255),
            )
    else:
        op.alter_column(
            "workspaces",
            "database_table_prefix",
            existing_nullable=True,
            nullable=False,
            existing_type=sa.String(length=255),
        )

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column("workspaces", "database_table_prefix")
    # ### end Alembic commands ###
